﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Windows.Editors;
using Infragistics.Windows.DataPresenter;
using System.Diagnostics;

namespace DifrentEditorsInField
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        
        public MainWindow()
        {
            InitializeComponent();
            DataSet set = new DataSet();

            set.Tables.Add(BuildTable("Parent"));
            xdg.DataSource = set.Tables[0].DefaultView;
            xdg.UpdateMode = UpdateMode.OnCellChangeOrLostFocus;

            List<bool> boolAnswers = new List<bool>();

            boolAnswers.Add(true);
            boolAnswers.Add(false);

            this.DataContext = boolAnswers;
        }




        private DataTable BuildTable(string name)
        {

            System.Data.DataTable table = new DataTable(name);
            DataColumn column;
            DataRow row;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Int32");
            column.ColumnName = "id";
            column.ReadOnly = true;
            table.Columns.Add(column);

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Question";
            column.AutoIncrement = false;
            column.Caption = "Question";
            column.ReadOnly = false;
            column.Unique = false;
            table.Columns.Add(column);

            column = new DataColumn();
           // column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Answer";
            column.AutoIncrement = false;
            column.Caption = "Answer";
            column.ReadOnly = false;
            column.Unique = false;
            table.Columns.Add(column);


            for (int i = 0; i <= 20; i++)
            {
                row = table.NewRow();
                row["id"] = i;
                row["Question"] = i;
                if (i % 3 == 0)
                    row["Answer"] = "String Data " + i;
                else if (i % 3 == 1)
                    row["Answer"] = DateTime.Now;
                else row["Answer"] = true;
                table.Rows.Add(row);
            }
            return table;

        }

    
        private void xdg_CellUpdated(object sender, Infragistics.Windows.DataPresenter.Events.CellUpdatedEventArgs e)
        {
            if (e.Cell.Field.Index == 1)
            {
                if (int.Parse(e.Cell.Value.ToString()) % 3 == 2) 
                {
                    e.Cell.Record.Cells[2].Value = false;
                }   
                else  e.Cell.Record.Cells[2].Value = null;                
            }
        }
    }



    public class MyConverter : IValueConverter
    {

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                int intValue;
                Int32.TryParse(value.ToString(), out intValue);
                if (intValue % 3 == 0)
                    return Application.Current.Resources["stringTemplate"] as DataTemplate;
                else if (intValue % 3 == 1)
                    return Application.Current.Resources["dateTimeTemplate"] as DataTemplate;
                else
                    return Application.Current.Resources["comboTemplate"] as DataTemplate;

            }
            else
                return Application.Current.Resources["stringTemplate"] as DataTemplate;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
